Subject: Re: How to count tx and rx bytes?

From: "David S. Miller" <[email-masked]>
Date: Mon, 15 Dec 2003 14:17:29 -0800

On Mon, 15 Dec 2003 12:03:58 -0800
Ben Greear <[email-masked]> wrote:

> Is there an agreed upon standard for exactly what ethernet drivers
> should be counting for rx-bytes and tx-bytes?  For example, should the
> counters include the 4-byte FCS?  Should they include the ethernet header?

Good question.

It should be that all drivers use what skb->len ends up with at
rx/tx time.

However, it is often faster to just let the hardware keep track
of these statistics (tg3 is one example of a chip that can do
this).  And sometimes these mechanisms take the FCS or whatever
into account and this as you note makes the numbers different.